<?php

namespace app\admin\controller\school\help;

use app\common\controller\Backend;
use think\exception\DbException;
use think\response\Json;

/**
 * 帮助文章
 *
 * @icon fa fa-circle-o
 */
class Article extends Backend
{

    /**
     * Article模型对象
     * @var \app\admin\model\school\help\Article
     */
    protected $model = null;

    protected $qSwitch = true;
    protected $qFields = ["help_cate_ids"];

    public function _initialize()
    {
        $this->model = new \app\admin\model\school\help\Article;
        parent::_initialize();

        $this->view->assign("statusList", $this->model->getStatusList());
        $this->view->assign("hotList", $this->model->getHotList());

        $this->view->assign("cateList", $this->model->getCateList());
        $this->view->assign("cateListJson", json_encode($this->model->getCateList(), JSON_UNESCAPED_UNICODE));
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */



    /**
     * 查看
     *
     * @return string|Json
     * @throws \think\Exception
     * @throws DbException
     */
    public function index()
    {
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if (false === $this->request->isAjax()) {
            return $this->view->fetch();
        }
        //如果发送的来源是 Selectpage，则转发到 Selectpage
        if ($this->request->request('keyField')) {
            return $this->selectpage();
        }
        list($where, $sort, $order, $offset, $limit, $page, $alias, $bind, $excludearray) = $this->buildparams(null, null, ["cate_title"]);

        if (isset($excludearray['cate_title']['value']) && $excludearray['cate_title']['value']) {
            $help_cate_ids = $excludearray['cate_title']['value'];
            $help_cate_ids =  implode("|",explode(',',$help_cate_ids));
            $expireWhere = ["help_cate_ids REGEXP '({$help_cate_ids})'"];
        } else {
            $expireWhere = ["1=1"];
        }
        $list = $this->model
            ->where($where)
            ->whereRaw(...$expireWhere)
            ->order($sort, $order)
            ->paginate($limit);
        $rows = $list->items();
        foreach ($rows as &$row){

        }

        $result = ['total' => $list->total(), 'rows' => $rows];
        return json($result);
    }

}
